const path = require('path');
const webpack = require('webpack');
const merge = require('webpack-merge');
const baseConfig = require('./webpack.base');

/**
 * Production configuration
 */
const browserConfig = merge(baseConfig, {
    devtool: 'source-map',
    mode: 'production',
    target: 'web',
    output: {
        path: path.resolve(__dirname, 'dist'),
        filename: 'apisearch-ui.min.js',
        libraryTarget: 'umd',
        library: 'apisearchUI',
        libraryExport: 'default'
    }
});

module.exports = [browserConfig];